(function($){
    function updatePreview($field) {
        var $variationField = $field.closest('.acf-field-variation-mode').find('.acf-variation-select input:checked');
        var $modeField = $field.closest('.acf-field-variation-mode').find('.acf-mode-select input:checked');
        var $preview = $field.closest('.acf-field-variation-mode').find('.acf-preview');
        
        if ($variationField.length && $modeField.length) {
            var variation = $variationField.val();
            var mode = $modeField.val();
            var variations = $field.closest('.acf-field-variation-mode').data('variations');
           
            var themeDir = themeData.themeDir;
            var previewImage = variations[variation] ? variations[variation][mode] : '';    
            if (previewImage) {
                previewImage = themeDir + previewImage;
                $preview.html('<img src="' + previewImage + '" alt="' + variation + ' ' + mode + ' preview" />');
            } else {
                $preview.html('<p>Image preview not available</p>');
            }
        } else {
            $preview.html('');
        }
    }

    $(document).on('click', '.acf-variation-select label', function(e){
        e.preventDefault();
        var $label = $(this);
        var $field = $label.closest('.acf-field-variation-mode');

        $field.find('.acf-variation-select label').removeClass('selected');
        $label.addClass('selected');
        $label.find('input').prop('checked', true).trigger('change');

        updatePreview($field);
    });

    $(document).on('click', '.acf-mode-select label', function(e){
        e.preventDefault();
        var $label = $(this);
        var $field = $label.closest('.acf-field-variation-mode');

        $field.find('.acf-mode-select label').removeClass('selected');
        $label.addClass('selected');
        $label.find('input').prop('checked', true).trigger('change');

        updatePreview($field);
    });

    $(document).on('acf/setup_fields', function(e, postbox) {
        $(postbox).find('.acf-field-variation-mode').each(function() {
            var $field = $(this);
            updatePreview($field);
        });
    });

})(jQuery);
